/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.mqtt;

import java.util.Map;
import rx.Observable;
import rx.Single;

/**
 * MQTT authentication information
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.mqtt.MqttAuth original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rxjava.RxGen(io.vertx.mqtt.MqttAuth.class)
public class MqttAuth {

  public static final io.vertx.lang.rxjava.TypeArg<MqttAuth> __TYPE_ARG = new io.vertx.lang.rxjava.TypeArg<>(
    obj -> new MqttAuth((io.vertx.mqtt.MqttAuth) obj),
    MqttAuth::getDelegate
  );

  private final io.vertx.mqtt.MqttAuth delegate;
  
  public MqttAuth(io.vertx.mqtt.MqttAuth delegate) {
    this.delegate = delegate;
  }

  public io.vertx.mqtt.MqttAuth getDelegate() {
    return delegate;
  }

  /**
   * @return the username provided by the remote MQTT client
   */
  public String userName() { 
    String ret = delegate.userName();
    return ret;
  }

  /**
   * @return the password provided by the remote MQTT client
   */
  public String password() { 
    String ret = delegate.password();
    return ret;
  }


  public static  MqttAuth newInstance(io.vertx.mqtt.MqttAuth arg) {
    return arg != null ? new MqttAuth(arg) : null;
  }
}
