/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.mqtt;

import java.util.Map;
import rx.Observable;
import rx.Single;

/**
 * Will information from the remote MQTT client
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.mqtt.MqttWill original} non RX-ified interface using Vert.x codegen.
 */

@io.vertx.lang.rxjava.RxGen(io.vertx.mqtt.MqttWill.class)
public class MqttWill {

  public static final io.vertx.lang.rxjava.TypeArg<MqttWill> __TYPE_ARG = new io.vertx.lang.rxjava.TypeArg<>(
    obj -> new MqttWill((io.vertx.mqtt.MqttWill) obj),
    MqttWill::getDelegate
  );

  private final io.vertx.mqtt.MqttWill delegate;
  
  public MqttWill(io.vertx.mqtt.MqttWill delegate) {
    this.delegate = delegate;
  }

  public io.vertx.mqtt.MqttWill getDelegate() {
    return delegate;
  }

  /**
   * @return the will flag for indicating the will message presence
   */
  public boolean isWillFlag() { 
    if (cached_0 != null) {
      return cached_0;
    }
    boolean ret = delegate.isWillFlag();
    cached_0 = ret;
    return ret;
  }

  /**
   * @return the topic for the will as provided by the remote MQTT client
   */
  public String willTopic() { 
    if (cached_1 != null) {
      return cached_1;
    }
    String ret = delegate.willTopic();
    cached_1 = ret;
    return ret;
  }

  /**
   * @return the payload for the will as provided by the remote MQTT client
   */
  public String willMessage() { 
    if (cached_2 != null) {
      return cached_2;
    }
    String ret = delegate.willMessage();
    cached_2 = ret;
    return ret;
  }

  /**
   * @return the QoS level for the will as provided by the remote MQTT client
   */
  public int willQos() { 
    if (cached_3 != null) {
      return cached_3;
    }
    int ret = delegate.willQos();
    cached_3 = ret;
    return ret;
  }

  /**
   * @return true if the will must be retained as provided by the remote MQTT client
   */
  public boolean isWillRetain() { 
    if (cached_4 != null) {
      return cached_4;
    }
    boolean ret = delegate.isWillRetain();
    cached_4 = ret;
    return ret;
  }

  private java.lang.Boolean cached_0;
  private String cached_1;
  private String cached_2;
  private java.lang.Integer cached_3;
  private java.lang.Boolean cached_4;

  public static  MqttWill newInstance(io.vertx.mqtt.MqttWill arg) {
    return arg != null ? new MqttWill(arg) : null;
  }
}
